import {Complex} from './type.js'
import {Signature, Dependency, ImpType} from '../core/Dispatcher.js'

declare module "./type" {
   interface ComplexReturn<Params> {
      isReal: Signature<Params, [Complex<any>], boolean>
      isSquare: Signature<Params, [Complex<any>], boolean>
   }
}

export const isReal =
   <T>(dep: Dependency<'equal', [T,T]>
       & Dependency<'add', [T,T]>
       & Dependency<'isReal', [T]>
      ): ImpType<'isReal', [Complex<T>]> =>
   z => dep.isReal(z.re) && dep.equal(z.re, dep.add(z.re, z.im))

export const isSquare: ImpType<'isSquare', [Complex<any>]> =
   z => true // FIXME: not correct for Complex<bigint> once we get there
